package mvc.gui;

import mvc.model.Counter;

/**
 * Main frame (window) of the example application,
 * holding the controller.
 * Note that it does not keep track of the open views.
 * The views are kept up to date by registering them as listeners
 * of the model.
 * 
 * @author Tom Verhoeff (TU/e)
 */
public class MainFrame extends javax.swing.JFrame {

    /** Creates new form MainFrame */
    public MainFrame() {
        initComponents();
        initFrame();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanelController = new javax.swing.JPanel();
        jButtonIncrement = new javax.swing.JButton();
        jButtonReset = new javax.swing.JButton();
        jButtonNewView = new javax.swing.JButton();
        jSeparator1 = new javax.swing.JSeparator();
        jComboBoxRadix = new javax.swing.JComboBox();
        jLabelRadix = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Controller");

        jPanelController.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPanelController.setToolTipText("Controller");

        jButtonIncrement.setFont(new java.awt.Font("Lucida Grande", 0, 18)); // NOI18N
        jButtonIncrement.setText("Increment");
        jButtonIncrement.setToolTipText("Increments count by one");
        jButtonIncrement.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonIncrementActionPerformed(evt);
            }
        });

        jButtonReset.setFont(new java.awt.Font("Lucida Grande", 0, 18)); // NOI18N
        jButtonReset.setText("Reset");
        jButtonReset.setToolTipText("Resets count to zero");
        jButtonReset.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonResetActionPerformed(evt);
            }
        });

        jButtonNewView.setFont(new java.awt.Font("Lucida Grande", 0, 18)); // NOI18N
        jButtonNewView.setText("New View");
        jButtonNewView.setToolTipText("Creates new view of counter with given radix");
        jButtonNewView.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonNewViewActionPerformed(evt);
            }
        });

        jComboBoxRadix.setFont(new java.awt.Font("Lucida Grande", 0, 18)); // NOI18N
        jComboBoxRadix.setMaximumRowCount(5);
        jComboBoxRadix.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "2", "3", "8", "10", "16" }));
        jComboBoxRadix.setSelectedIndex(3);
        jComboBoxRadix.setToolTipText("Radix for new view");

        jLabelRadix.setFont(new java.awt.Font("Lucida Grande", 0, 18)); // NOI18N
        jLabelRadix.setText("Radix");

        org.jdesktop.layout.GroupLayout jPanelControllerLayout = new org.jdesktop.layout.GroupLayout(jPanelController);
        jPanelController.setLayout(jPanelControllerLayout);
        jPanelControllerLayout.setHorizontalGroup(
            jPanelControllerLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanelControllerLayout.createSequentialGroup()
                .addContainerGap()
                .add(jPanelControllerLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jButtonReset, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(jButtonIncrement, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 157, Short.MAX_VALUE)
                    .add(jButtonNewView, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(jSeparator1)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanelControllerLayout.createSequentialGroup()
                        .add(jLabelRadix, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jComboBoxRadix, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 84, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        jPanelControllerLayout.setVerticalGroup(
            jPanelControllerLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanelControllerLayout.createSequentialGroup()
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .add(jPanelControllerLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jComboBoxRadix, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabelRadix))
                .add(18, 18, 18)
                .add(jButtonNewView)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jSeparator1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jButtonIncrement)
                .add(18, 18, 18)
                .add(jButtonReset)
                .addContainerGap())
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanelController, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanelController, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButtonIncrementActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonIncrementActionPerformed
        model.increment();
        updateFrame();
    }//GEN-LAST:event_jButtonIncrementActionPerformed

    private void jButtonResetActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonResetActionPerformed
        model.reset();
        updateFrame();
    }//GEN-LAST:event_jButtonResetActionPerformed

    private void jButtonNewViewActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonNewViewActionPerformed
        final int count = model.getCount();
        final int radix = Integer.parseInt(
                (String) (jComboBoxRadix.getSelectedItem()));
        final ViewFrame viewFrame = new ViewFrame(count, radix);
        model.addListener(viewFrame);
    }//GEN-LAST:event_jButtonNewViewActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(MainFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(MainFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(MainFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(MainFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                new MainFrame().setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonIncrement;
    private javax.swing.JButton jButtonNewView;
    private javax.swing.JButton jButtonReset;
    private javax.swing.JComboBox jComboBoxRadix;
    private javax.swing.JLabel jLabelRadix;
    private javax.swing.JPanel jPanelController;
    private javax.swing.JSeparator jSeparator1;
    // End of variables declaration//GEN-END:variables

    /** The model (model) */
    private Counter model;

    /** Initialize this frame. */
    private void initFrame() {
        model = new Counter();
        updateFrame();
    }
    
    /** Update this frame, both controller and view. */
    private void updateFrame() {
        repaint();
    }
    
}
