package mvc.model;

import java.util.EventListener;

/**
 * Interface with events that can be triggered by a counter.
 * 
 * @author Tom Verhoeff (TU/e)
 */
public interface CounterListener extends EventListener {
    
    /**
     * Signals a change in the counter.
     * The parameter {@code newCount} <em>pushes</em> the change
     * to the observer.
     * Without this parameter, the observer would need to <em>pull</em>
     * the new state from the counter via a query.
     * 
     * @param newCount  the new state of the observed counter
     */
    void counterChanged(int newCount);

}
